#!/bin/sh

L_FLAG=OFF			# -l $B%*%W%7%g%s$,;XDj$5$l$?$+$rH=Dj$9$k%U%i%0(B
S_FLAG=OFF			# -s $B%*%W%7%g%s$,;XDj$5$l$?$+$rH=Dj$9$k%U%i%0(B
SIGNAL=TERM			# -s $B%*%W%7%g%s$N0z?t!JAw?.$9$k%7%0%J%k!K(B
SYSTEM=				# $B%7%9%F%`L>>N!J(BSolaris $B$+$=$l0J30!K(B
PROCESS_NAME=			# $B%7%0%J%k$rAw?.$9$k%W%m%;%9L>>N!J0z?t$G$N;XDj!K(B
PROCESS_LINE=			# $B$=$NJ8;zNs$r4^$`%W%m%;%9$G(B 1 $BHV>.$5$$(B PID $B$N9T(B
PROCESS_PID=			# $B3:Ev$N%W%m%;%9$N%W%m%;%9HV9f(B

while getopts ls: OPTION		# getopts $B$G%*%W%7%g%s=hM}(B
do
    case $OPTION in
      l) L_FLAG=ON ;;			# -l $B%*%W%7%g%s;XDj(B
      s) S_FLAG=ON			# -s $B%*%W%7%g%s;XDj(B
         SIGNAL=$OPTARG ;;		# $BAw$k%7%0%J%k$O(B SIGNAL $B$H$$$&JQ?t$KBeF~$5$l$k(B
     \?) echo "Usage: $0 [-s signal | -l] process_name" 1>&2
         exit 1 ;;
    esac
done

shift `expr $OPTIND - 1`			# $B%*%W%7%g%s0J30$N0z?t$N(B 1 $BHVL\$,(B $1 $B$X(B
if [ $# -eq 0 ]; then				# $1 $B$,$J$+$C$?$i(B
    echo "Specify killed process_name" 1>&2	# $B%(%i!<(B
    exit 1
fi
if [ $L_FLAG = ON -a $S_FLAG = ON ]; then		# -l $B$H(B -s $B$rF1;~$K;XDj$7$?$i(B
    echo "Specify either (-s signal) or (-l)" 1>&2	# $B%(%i!<(B
    exit 1
fi
PROCESS_NAME=$1				# $1 $B$r(B PROCESS_NAME $B$XBeF~!J$=$NB>$N0z?t$OL5;k!K(B

SYSTEM=`uname -s`			# uname -s $B$N7k2L$G%7%9%F%`$rH=Dj(B
if [ $SYSTEM = SunOS ]; then		# Solaris $B$@$C$?$i(B
    PS="ps -ef"				# ps -ef $B$r;H$&(B
else					# $B$=$NB>$O(B
    PS="ps ax"				# ps ax $B$r;H$&(B
fi

if [ $SYSTEM = SunOS ]; then					# $B3:Ev$N%W%m%;%99T$NCj=P(B
    PROCESS_LINE=`$PS | grep $PROCESS_NAME | grep -v grep \
                | grep -v $0 | sort -k 2 | head -1`
    PROCESS_PID=`echo $PROCESS_LINE | awk '{print $2}'`		# $B3:Ev$N%W%m%;%9(B ID $B$NCj=P(B
else
    PROCESS_LINE=`$PS | grep $PROCESS_NAME | grep -v grep \
                | grep -v $0 | sort -k 1 | head -1`
    PROCESS_PID=`echo $PROCESS_LINE | awk '{print $1}'`
fi

if [ "$PROCESS_LINE" = "" ]; then		# $B3:Ev$N%W%m%;%99T$,$J$+$C$?$H$-(B
    echo "No such process <$PROCESS_NAME>."	# $B$J$$$H$$$&%a%C%;!<%8$r=P$7$F=*N;(B
    exit 0
fi

if [ $L_FLAG = ON ]; then		# -l $B%*%W%7%g%s;XDj$N$H$-$O(B
    echo "you may kill this line:"
    echo "-> $PROCESS_LINE"		# $B3:Ev$N%W%m%;%99T$r=PNO$9$k(B
else					# $B$=$l0J30!J(B-s $B;XDj$+%*%W%7%g%s$J$7!K$N$H$-$O(B
    kill -$SIGNAL $PROCESS_PID		# $B%7%0%J%k$rAw$k(B
fi
