#!/bin/sh

Usage="Usage: $0 [-c] [dir...]"		# Usage $B$bJQ99$K$J$k(B
CFLAG=OFF				# -c $B$,;XDj$5$l$?$H$-(B ON $B$K$9$k(B
CURRENT_DIR=`pwd`			# $B%+%l%s%H%G%#%l%/%H%j(B

Atoa(){					# $BJQ99$J$7(B
  echo $* | tr '[A-Z]' '[a-z]'
}

extent_check(){				# $BJQ99$J$7(B
  EXTENT=`echo $1 | sed -e 's/\(.*\)\.\(.*\)/\2/'`
  case $EXTENT in
      [jJ][pP][gG]) echo $1 ;;
      [bB][mM][pP]) echo $1 ;;
                * ) ;;
  esac
}

file_body(){				# $BJQ99$J$7(B
  FILEBODY=`echo $1 | sed -e 's/\(.*\)\.\(.*\)/\1/'`
  echo $FILEBODY
}

check_duplicate(){			# $B=EJ#$,$"$C$?>l9g$N%G%#%l%/%H%jI=<($rDI2C(B
  for file in *.*
  do
      if [ "`extent_check $file`" != "" ]; then
          Atoa $file >> /tmp/tempfile01$$
          Atoa `file_body $file` >> /tmp/tempfile02$$
      else
          continue
      fi
  done
  if [ -s /tmp/tempfile01$$ ]; then
      sort /tmp/tempfile01$$ | uniq -d > /tmp/tempfile03$$
      if [ -s /tmp/tempfile03$$ ]; then
          echo "Following files are duplicated after Atoa"
          echo `pwd`						# $B%G%#%l%/%H%jI=<($rDI2C(B
          cat /tmp/tempfile03$$
      fi
      sort /tmp/tempfile02$$ | uniq -d > /tmp/tempfile03$$
      if [ -s /tmp/tempfile03$$ ]; then
          echo "Following files are duplicated after convert"
          echo `pwd`						# $B%G%#%l%/%H%jI=<($rDI2C(B
          cat /tmp/tempfile03$$
      fi
      rm -f /tmp/tempfile0[123]$$
      exit 1
  fi
}

while getopts c OPTION
do
    case $OPTION in
      c) CFLAG=ON  ;;		# -c $B$N$H$-%U%i%0$r(B ON $B$K$9$k!J=hM}$O8e2s$7!K(B
      ?) echo $Usage 1>&2
         exit 1 ;;
    esac
done

shift `expr $OPTIND - 1`	# $B0z?t$N%A%'%C%/$,$"$k$N$GI,MW(B

if [ $# -eq 0 ]; then		# $B0z?t;XDj$,$J$+$C$?$i(B
    DIRECTORY=$CURRENT_DIR	# $B%+%l%s%H%G%#%l%/%H%j$,BP>](B
else				# $B2?$i$+$N;XDj$,$"$C$?$i(B
    DIRECTORY="$@"		# $B0z?t$r$=$N$^$^JQ?t$KBeF~(B
fi

for dir in $DIRECTORY			# $B0z?t$N%G%#%l%/%H%jA4It$,BP>]$H$J$k(B
do
    if [ -d $dir ]; then		# $B;XDj$5$l$?$N$,%G%#%l%/%H%j$@$C$?$i(B
        cd $dir				# $B$=$3$X0\F0$9$k(B
        if [ $CFLAG = ON ]; then	# -c $B%*%W%7%g%s$,;XDj$5$l$F$$$?$i(B
            check_duplicate		# $B%U%!%$%kL>>N$N=EJ#%A%'%C%/(B
        fi
        for file in *.*			# $B$"$H$N=hM}$OJQ$o$i$:(B
        do
            if [ "`extent_check $file`" != "" ]; then
                case $file in
                    *[A-Z]*) mv $file `Atoa $file` ;;
                         * ) continue ;;
                esac
            fi
        done
        for file in *.jpg *.bmp
        do
            if [ -f $file ]; then
		CONVFILE=`file_body $file`
		convert -resize 120x120 $file ${CONVFILE}_tn.jpg
	    fi
        done
        cd $CURRENT_DIR		# $B$b$H$N%G%#%l%/%H%j$KLa$C$F<!$N%G%#%l%/%H%j=hM}$X(B
    fi				# $B;XDj$5$l$?$N$,%G%#%l%/%H%j$8$c$J$+$C$?$i2?$b$7$J$$(B
done
