#!/bin/sh

Usage="Usage: $0 [-c] [dir...]"		# $B%*%W%7%g%s$,4V0c$C$?$H$-$N%a%C%;!<%8(B
CFLAG=OFF				# -c $B$,;XDj$5$l$?$H$-(B ON $B$K$9$k(B
DUPLICATE=OFF				# $B=EJ#$,$*$-$k$+$I$&$+$N%U%i%0(B
CURRENT_DIR=`pwd`			# $B%+%l%s%H%G%#%l%/%H%j(B

Atoa(){					# $BBgJ8;z$r>.J8;z$K$9$k4X?t(B
  echo $* | tr '[A-Z]' '[a-z]'
}

extent_check(){				# $B3HD%;R$rFCDj$9$k4X?t(B
  EXTENT=`echo $1 | sed -e 's/\(.*\)\.\(.*\)/\2/'`
  case $EXTENT in
      [jJ][pP][gG]) echo $1 ;;
      [bB][mM][pP]) echo $1 ;;
                * ) ;;
  esac
}

file_body(){				# $B%U%!%$%kL>$+$i3HD%;R0J30$r<h$j=P$94X?t(B
  FILEBODY=`echo $1 | sed -e 's/\(.*\)\.\(.*\)/\1/'`
  echo $FILEBODY
}

check_duplicate(){			# $B=EJ#%U%!%$%kL>$,$G$-$k$+$I$&$+$N%A%'%C%/!J:F5"HG!K(B
  for file in *.*
  do
      if [ "`extent_check $file`" != "" ]; then
          Atoa $file >> /tmp/tempfile01$$
          Atoa `file_body $file` >> /tmp/tempfile02$$
      else
          continue
      fi
  done
  if [ -s /tmp/tempfile01$$ ]; then
      sort /tmp/tempfile01$$ | uniq -d > /tmp/tempfile03$$
      if [ -s /tmp/tempfile03$$ ]; then
          echo "Following files are duplicated after Atoa"
          echo `pwd`
          cat /tmp/tempfile03$$
	  DUPLICATE=ON			# $B=EJ#$9$k$H$$$&%U%i%0$r%*%s$K$9$k(B
      fi
      sort /tmp/tempfile02$$ | uniq -d > /tmp/tempfile03$$
      if [ -s /tmp/tempfile03$$ ]; then
          echo "Following files are duplicated after convert"
          echo `pwd`
          cat /tmp/tempfile03$$
	  DUPLICATE=ON			# $B=EJ#$9$k$H$$$&%U%i%0$r%*%s$K$9$k(B
      fi
      rm -f /tmp/tempfile0[123]$$	# $BCf4V%U%!%$%k$O%G%#%l%/%H%j$4$H$K;H$$2s$9(B
  fi
  for dir in *				# $B<!$K!"$=$N%G%#%l%/%H%jFb$K%5%V%G%#%l%/%H%j$,(B
  do					# $B$"$k$+$I$&$+$rD4$Y$k(B
      if [ -d $dir ]; then	 	# $B%5%V%G%#%l%/%H%j$,B8:_$7$F$$$?$i(B
          (cd $dir; check_duplicate)	# $B$=$3$X0\F0$7=EJ#%A%'%C%/$r9T$J$&(B
      fi
  done
}

make_thumbnail(){			# $B%5%`%M%$%k:n@.4X?t!J:F5"HG!K(B
  for file in *.*
  do
      if [ "`extent_check $file`" != "" ]; then
           case $file in
               *[A-Z]*) mv $file `Atoa $file` ;;
                    * ) continue ;;
           esac
      fi
  done
  for file in *.jpg *.bmp
  do
      if [ -f $file ]; then
	   CONVFILE=`file_body $file`
	   convert -resize 120x120 $file ${CONVFILE}_tn.jpg
      fi
  done
  for dir in *				# $B<!$K!"$=$N%G%#%l%/%H%jFb$K%5%V%G%#%l%/%H%j$,(B
  do					# $B$"$k$+$I$&$+$rD4$Y$k(B
      if [ -d $dir ]; then	 	# $B%5%V%G%#%l%/%H%j$,B8:_$7$F$$$?$i(B
          (cd $dir; make_thumbnail)	# $B$=$3$X0\F0$7%5%`%M%$%k:n@.=hM}$r9T$J$&(B
      fi
  done
}

while getopts c OPTION
do
    case $OPTION in
      c) CFLAG=ON  ;;		# -c $B$N$H$-%U%i%0$r(B ON $B$K$9$k(B
      ?) echo $Usage 1>&2
         exit 1 ;;
    esac
done

shift `expr $OPTIND - 1`	# $B%*%W%7%g%s0J30$N0z?t$N%A%'%C%/(B

if [ $# -eq 0 ]; then		# $B0z?t;XDj$,$J$+$C$?$i(B
    DIRECTORY=$CURRENT_DIR	# $B%+%l%s%H%G%#%l%/%H%j$,BP>](B
else				# $B2?$i$+$N;XDj$,$"$C$?$i(B
    DIRECTORY="$@"		# $B0z?t$r$=$N$^$^JQ?t$KBeF~(B
fi

if [ $CFLAG = ON ]; then	# -c $B%*%W%7%g%s;XDj;~(B
    for dir in $DIRECTORY 	# $B;O$a$K;XDj$5$l$?%G%#%l%/%H%j$KBP$7$F(B
    do				# $BA4It=EJ#%A%'%C%/$r9T$J$&(B
        if [ -d $dir ]; then	# $B$7$+$b%5%V%G%#%l%/%H%j$^$G(B
            cd $dir
            check_duplicate	# $B=EJ#$9$k$N$J$i$3$3$G%a%C%;!<%8$r=P$7!"(B
            cd $CURRENT_DIR	# $B%U%i%0$,%*%s$H$J$k(B
        fi
    done
fi

if [ $DUPLICATE = OFF ]; then	# -c $B;XDj$,$J$$$+!"%U%i%0$,%*%U$J$i(B
    for dir in $DIRECTORY	# $B<B:]$N%5%`%M%$%k:n@.=hM}$r9T$J$&(B
    do
        if [ -d $dir ]; then	# $B0z?t$K;XDj$5$l$?$N$,%G%#%l%/%H%j$@$C$?$i(B
            cd $dir
            make_thumbnail	# make_thumbnail $B$r<B9T$9$k(B
            cd $CURRENT_DIR	# $B$b$H$N%G%#%l%/%H%j$KLa$C$F<!$N%G%#%l%/%H%j=hM}$X(B
        fi
    done
fi
